// MOD Player for 32X - by  Chilly Willy
// Color Cycle 32X - by Mic

#include <sys/types.h>
#include <string.h>
#include <stdint.h>

#include "32x.h"
#include "hw_32x.h"
#include "module.h"
#include "sound.h"

uint16_t __attribute__((aligned(16))) data[128*512];

struct ModTag __attribute__((aligned(16))) mod;

const int16_t sintb[] = {0,7,15,23,31,39,46,54,61,69,76,84,91,98,105,112,118,125,131,137,143,
149,155,160,165,170,175,180,184,188,192,196,199,202,205,208,211,213,
215,217,218,220,221,221,222,222,223,222,222,222,221,220,219,217,216,
214,212,210,208,206,203,200,198,195,192,188,185,182,178,175,171,167,
163,160,156,152,148,144,140,136,132,128,124,120,116,112,108,104,100,
96,93,89,85,82,78,75,71,68,65,62,59,56,53,50,47,44,42,39,37,34,32,30,
28,26,24,22,20,18,16,14,12,11,9,7,6,4,3,1,0,-2,-4,-5,-7,-8,-10,-12,
-13,-15,-17,-19,-21,-23,-25,-27,-29,-31,-33,-35,-38,-40,-43,-45,-48,
-51,-54,-56,-59,-63,-66,-69,-72,-76,-79,-83,-86,-90,-93,-97,-101,-105,
-109,-113,-117,-121,-125,-129,-133,-137,-141,-145,-149,-153,-157,-160,
-164,-168,-172,-175,-179,-183,-186,-189,-192,-196,-198,-201,-204,-207,
-209,-211,-213,-215,-217,-218,-220,-221,-222,-223,-223,-223,-224,-223,
-223,-222,-222,-221,-219,-218,-216,-214,-212,-209,-207,-204,-200,-197,
-193,-189,-185,-181,-176,-171,-166,-161,-156,-150,-144,-138,-132,-126,
-119,-113,-106,-99,-92,-85,-78,-70,-63,-55,-47,-40,-32,-24,-16,-9};

void color_cycle(void)
{
    int i, j, k;
    static int d = 0;
    static uint8_t d2 = 0, d3 = 0;
    int16_t p;
    volatile uint8_t *frameBuffer = (volatile uint8_t *)&MARS_FRAMEBUFFER;

    k = 0x200;
    for (i=0; i<224; i++)
    {
        for (j=0; j<320; j++)
        {
            p = ((i + (sintb[(j+(i>>1)+d)&255]>>4)) ^ (j + (sintb[(i+d)&255]>>4))) & 63;
            p += sintb[(d2+i+j)&255];
            p += sintb[(d3+j)&255];
            p += sintb[(d2+d3+i+j)&255];
            frameBuffer[k++] = (p>>2);
        }
    }
    d += 2;
    d2 += 2;
    d3 -= 1;

    Hw32xScreenFlip(1);
}

int main(void)
{
    int i, j;
    volatile uint16_t *palette = &MARS_CRAM;

    Hw32xInit(MARS_VDP_MODE_256);

    // Set up the palette
    for (i=0; i<64; i++)
    {
        palette[i] = COLOR(i>>1,0,i>>1);
        palette[i+64] = COLOR(31,i>>1,31);
        palette[i+128] = COLOR(31,31,31-(i>>1));
        palette[i+192] = COLOR(31-(i>>1),31-(i>>1),0);
    }

#if 0
    // init DMA channel 0 & 1
    SH2_DMA_SAR0 = (int)&MARS_SYS_DMAFIFO;
    SH2_DMA_DAR0 = 0;
    SH2_DMA_TCR0 = 0;
    SH2_DMA_CHCR0 = 0;
    SH2_DMA_DRCR0 = 0;
    SH2_DMA_SAR1 = 0;
    SH2_DMA_DAR1 = 0;
    SH2_DMA_TCR1 = 0;
    SH2_DMA_CHCR1 = 0;
    SH2_DMA_DRCR1 = 0;
    SH2_DMA_DMAOR = 1; // enable DMA
#endif

    while (1)
    {
        // flush data[]
        for (i=0; i<65536; i+=8)
            CacheClearLine(&data[i]);
        MARS_SYS_COMM4 = 0x0001; // tell Slave SH2 to flush data[]
        while (MARS_SYS_COMM4) ; // wait until flushed

#if 0
    {
        char temp[44];
        Hw32xSetFGColor(128,31,31,31);
        Hw32xSetBGColor(1,0,0,0);
        strcpy(temp, "waiting...        ");
        Hw32xScreenSetXY(1, 24);
        Hw32xScreenPuts(temp);
    }
#endif
        // transfer MOD
        // wait for CD/MD
        while (!MARS_SYS_COMM0) ;

#if 0
    {
        char temp[44];
        Hw32xSetFGColor(128,31,31,31);
        Hw32xSetBGColor(1,0,0,0);
        strcpy(temp, "starting xfer...  ");
        Hw32xScreenSetXY(1, 24);
        Hw32xScreenPuts(temp);
    }
#endif
        // transfer MOD
#if 0
        while (!(MARS_SYS_DMACTR & MARS_SYS_DMA_68S)) ; // wait for SH DREQ to start
        j = MARS_SYS_COMM2; // # words to DMA
        if (j == 0)
            j = 0x10000; // 0 => 64K words
        SH2_DMA_DAR0 = 0x20000000 | (int)&data;
        SH2_DMA_TCR0 = j;
        SH2_DMA_CHCR0 = 0x44E1;
        MARS_SYS_COMM0 = 0x55AA; // SH2 DMA started
        while (!(SH2_DMA_CHCR0 & 2)) ; // wait on TE
        SH2_DMA_CHCR0 = 0x44E0; // clear DMA TE
#else
        i = j = 0;
        while (MARS_SYS_COMM0 != 0xFFFF)
        {
            while (MARS_SYS_COMM0 == 1) ;
            if (MARS_SYS_COMM0 != 0xFFFF)
            {
                if (i < 128*512)
                    data[i++] = MARS_SYS_COMM2;
                MARS_SYS_COMM0 = 1;
            }
        }
        MARS_SYS_COMM2 = 1;
        MARS_SYS_COMM0 = 0; // xfer done
#endif

#if 0
    {
        char temp[44];
        Hw32xSetFGColor(128,31,31,31);
        Hw32xSetBGColor(1,0,0,0);
        strcpy(temp, "xfer done              ");
        Hw32xScreenSetXY(1, 24);
        Hw32xScreenPuts(temp);
    }
#endif
#if 0
    {
        char temp[44];
        Hw32xSetFGColor(128,31,31,31);
        Hw32xSetBGColor(1,0,0,0);
        memcpy(temp, (char *)data, 20);
        temp[20] = 0;
        Hw32xScreenSetXY(20, 26);
        Hw32xScreenPuts(temp);
        Hw32xDelay(300);
    }
#endif

        // start MOD playing - loop until press any button
        InitMOD((uint8_t *)data, &mod);
        VolumeMOD(12);
        StartMOD(&mod, 1); // start with looping
        while (!(MARS_SYS_COMM8 & SEGA_CTRL_BUTTONS))
            color_cycle();
        while (MARS_SYS_COMM8 & SEGA_CTRL_BUTTONS) ;
        ExitMOD(&mod);

        Hw32xScreenClear();
        MARS_SYS_COMM0 = MARS_SYS_COMM2 = 0; // done
    }

    return 0;
}
